//
// npcpumon.h 
//

#ifndef _NPCPUMON_H_
#define _NPCPUMON_H_


class CPluginWindow;

// CCpuMon class

class CCpuMon
{
// Construction
public:
	CCpuMon (NPP pInstance);
	~CCpuMon ();

// Attributes
public:

	CPluginWindow* 	pWindow;
	NPStream*		pStream;
	NPP				pInstance;
	uint16			mode;

private:

	char	ProgramURL[1024];
	BOOL	bRunningCGIProgram;
	
// Operations
public:
		
	BOOL 	Open (NPStream*	pStream);	// Called from NPP_NewStream
	BOOL 	Close (void);	// Called from NPP_Destroy
	
	BOOL	EndOfStream (void);	// Called from NPP_DestroyStream
	BOOL	GotFileName	(const char* fname);
	BOOL	RequestUpdate (void);
	
private:

};

#endif /* _NPCPUMON_H_ */




