#ifndef CHARQUEUE_H
#define CHARQUEUE_H

class charQueue
{
	public:
		charQueue();
		~charQueue();
		void add(char aChar);
		char remove();

	class BufferFullException
		{
		};

	class QueueEmpty
		{
		};	

	private:
		class listNode
		{
			friend class charQueue;
			static listNode* kNull;
			public:
				listNode();
				char fChar;
				listNode* fPrevious;
				listNode* fNext;
		};
		listNode* fHead;
		listNode* fTail;

};

#endif