// npChap04Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "npChap04.h"
#include "npChap04Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNpChap04Dlg dialog

CNpChap04Dlg::CNpChap04Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNpChap04Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNpChap04Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
#ifdef _PLUG_IN
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
#endif
}

void CNpChap04Dlg::PrepareDialog()
{
	CRect rectTmp(10,10,80,50);

	cbExample = new CButton();
	cbExample->Create("OK",BS_PUSHBUTTON | WS_VISIBLE,
			rectTmp,this,IDOK);

	rectTmp.SetRect(100,10,180,50);
	cbCancel = new CButton;
	cbCancel->Create("Cancel",BS_PUSHBUTTON | WS_VISIBLE,
			rectTmp,this,IDCANCEL);
}

void CNpChap04Dlg::EatDialog()
{
	ASSERT(cbExample != NULL);
	delete cbExample;
	ASSERT(cbExample != NULL);
	delete cbCancel;
}

void CNpChap04Dlg::UnSubclassWindow()
{
	// restore original Netscape WNDPROC
	WNDPROC* lplpfn = GetSuperWndProcAddr();
	if ( !*lplpfn )
	{
		ASSERT(0);
		return;
	}

	// Set the original window procedure using Windows AFI function
	(WNDPROC)::SetWindowLong(m_hWnd, GWL_WNDPROC, (LONG) *lplpfn );
}

void CNpChap04Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNpChap04Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNpChap04Dlg, CDialog)
	//{{AFX_MSG_MAP(CNpChap04Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNpChap04Dlg message handlers

BOOL CNpChap04Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNpChap04Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNpChap04Dlg::OnPaint() 
{
#ifdef _PLUG_IN
	Cstring s = "Hello, world!";
	
	Crect rect;
	CPaintDC dcTmp(This);
	GetClientRect(rect);

	dcTmp.SetTextAlign(TA_BASELINE | TA_CENTER);
	dcTmp.SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	dcTmp.SetBkMode(TRANSPARENT);
	dcTmp.TextOut((rect.right / 2), (rect.bottom / 2), s);
#else
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
#endif
		CDialog::OnPaint();
#ifndef _PLUG_IN
	}
#endif
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNpChap04Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNpChap04Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CNpChap04Dlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

